using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace GF_p_
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine(new GF(2) * (new GF(3) + new GF(5)));
            Console.WriteLine(new GF(2) * new GF(3) + new GF(2) * new GF(5));

            Console.ReadLine();
        }
    }

    struct GF
    {
        public const uint P = 7; // Primzahl
        private uint value;
        public uint Value
        {
            get
            {
                return value;
            }
            set
            {
                Debug.Assert(value < P);
                Value = value;
            }
        }
        public GF(uint value)
        {
            Debug.Assert(value < P);
            this.value = value;
        }
        public override string ToString()
        {
            return Value.ToString();
        }
        public static GF operator +(GF a, GF b)
        {
            return new GF((a.Value + b.Value) % P);
        }
        public static GF operator *(GF a, GF b)
        {
            return new GF((a.Value * b.Value) % P);
        }
        public static GF operator -(GF a, GF b)
        {
            return new GF((a.Value - b.Value + P) % P);
        }
        private static uint[] reciprocals = new uint[P]; // reciprocals[0] bleibt ungenutzt
        static GF()
        {
            for (uint i = 1; i < P; i++)
            {
                for (uint j = 1; j < P; j++)
                {
                    if ((i * j) % P == 1)
                    {
                        reciprocals[i] = j;
                    }
                }
            }
        }
        public static GF operator /(GF a, GF b)
        {
            Debug.Assert(b.Value != 0);
            uint bInv = reciprocals[b.Value];
            return new GF((a.Value * bInv) % P);
        }
    }

}
